/*script
open picaar
user ftp ftp
cd img8
bin
get filelist.txt c:\tmp\filelist.txt
quit
..
open picaar
user ftp ftp
bin
get img8/P44.LZH c:\tmp\img8\P44.LZH
get img8/P45.LZH c:\tmp\img8\P45.LZH
quit
*/
#define STRICT
#include <windows.h>
#include "winsock.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <direct.h>
#include "pocftp.rid"

SOCKET sControl=INVALID_SOCKET;
SOCKET sData=INVALID_SOCKET;

char cmdline[512];      //current script line
char *argv[20];
int argc;

enum {
        cmd_open,
        cmd_user,
        cmd_cd,
        cmd_bin,
        cmd_lcd,
        cmd_get,
        cmd_quit,
        cmd_noop,
        cmd_unknown
} cmd;

int abortScript=0; //set when something goes wrong or the user cancels the script

FILE *script;

HWND hwndDialog=NULL;


static void SetStatus(const char *s1, const char *s2);
static void PeekMessageLoop();

//script reading and parsing---------------------------------------------------
static void readScriptCommand() {
        if(fgets(cmdline,512,script)) {
                char *p=strtok(cmdline," \t\n\r");
                argc=0;
                while(p) {
                        argv[argc++] = p;
                        p = strtok(0," \t\n\r");
                }
                if(argc==0) {
                        cmd = cmd_noop;
                } else {
                        if(stricmp(argv[0],"open")==0)
                                cmd = cmd_open;
                        else if(stricmp(argv[0],"user")==0)
                                cmd = cmd_user;
                        else if(stricmp(argv[0],"cd")==0)
                                cmd = cmd_cd;
                        else if(stricmp(argv[0],"bin")==0)
                                cmd = cmd_bin;
                        else if(stricmp(argv[0],"lcd")==0)
                                cmd = cmd_lcd;
                        else if(stricmp(argv[0],"get")==0)
                                cmd = cmd_get;
                        else if(stricmp(argv[0],"quit")==0)
                                cmd = cmd_quit;
                        else if(stricmp(argv[0],"noop")==0)
                                cmd = cmd_noop;
                        else
                                cmd = cmd_unknown;
                }
        } else {
                cmd = cmd_quit;
        }
}

//command/response-------------------------------------------------------------
static void sendcmd(const char *s) {
        ::send(sControl,s,strlen(s),0);
}

static void readline(char *l) {
        for(;;) {
                int bytes = ::recv(sControl,l,1,0);
                if(bytes>=1) {
                        if(*l++ == '\n')
                                break;
                } else
                        break;
        }
        *l='\0';
}

static char reply[512];

static int readreply() {
        readline(reply);
        if(reply[3]=='-') {
                //multiline response
                for(;;) {
                        char l2[512];
                        readline(l2);
                        if(l2[3]==' ' && memcmp(reply,l2,3)==0) {
                                strcpy(reply,l2);
                                break;
                        }
                }
        }
        return atoi(reply);
}

//misc-------------------------------------------------------------------------
u_long hostaddress(const char *hostname) {
        //convert hostname or ascii dotted ip address
        const char *p;
        for(p=hostname; *p; p++){
                if(!((*p>='0' && *p<'9') || *p=='.')) {
                        struct hostent *he=gethostbyname((char*)hostname);
                        if(he) {
                                u_long a;
                                a = ((struct in_addr*)(he->h_addr_list[0]))->s_addr;
                                a = ntohl(a);
                                return a;
                        } else
                                return 0;
                }
        }
        u_long a;
        a = inet_addr((char*)hostname);
        a = ntohl(a);
        return a;
}

unsigned short serviceport(const char *service) {
        char *endptr;
        unsigned short port=(unsigned short)strtol(service,&endptr,0);
        if(endptr && *endptr) {
                /* not digits */
                struct servent *se=getservbyname((char*)service,"tcp");
                if(se) {
                        return ntohs(se->s_port);
                } else
                        return 0;
        } else
                return port;
}


//FTP operations---------------------------------------------------------------
static void do_open() {
        //arguments: host [port]
        SetStatus("Opening connection","");
        if(argc<2 || argc>3) {
                MessageBox(hwndDialog,"Open: incorrect number of arguments","poc ftp",MB_OK);
                abortScript=1;
                return;
        }
        sControl = ::socket(PF_INET,SOCK_STREAM,0);
        if(sControl==INVALID_SOCKET) {
                MessageBox(hwndDialog,"Could not create socket","poc ftp",MB_OK|MB_ICONSTOP);
                abortScript=1;
                return;
        }
        
        struct sockaddr_in name;
        memset(&name,0,sizeof(name));
        name.sin_family = AF_INET;
        name.sin_addr.s_addr = htonl(hostaddress(argv[1]));
        if(argc>=3)
                name.sin_port = htons(serviceport(argv[2]));
        else
                name.sin_port = htons(serviceport("ftp"));
        SetStatus(0,"Connecting");
        if(::connect(sControl,(sockaddr*)&name,sizeof(name))!=0) {
                MessageBox(hwndDialog,"Could not connect to host","poc ftp",MB_OK|MB_ICONSTOP);
                abortScript=1;
                return;
        }
        SetStatus(0,"Reading greeting");

        //disable nagle algorithm since ftp commands are ver short and we dont want a delay
        BOOL nagle=FALSE;
        setsockopt(sControl,IPPROTO_TCP,TCP_NODELAY,(char*)&nagle,sizeof(nagle));
        
        int r = readreply();
        if(r!=220) {
                MessageBox(hwndDialog,reply,"POC ftp - server error",MB_OK|MB_ICONSTOP);
                abortScript=1;
                return;
        }
        
}

static void do_user() {
        //arguments: userid [passwd]
        SetStatus("Logging in","");
        if(argc<2 || argc>3) {
                MessageBox(hwndDialog,"User: incorrect number of arguments","poc ftp",MB_OK);
                abortScript=1;
                return;
        }
        char s[80];
        wsprintf(s,"user %s\n",argv[1]);
        SetStatus(0,"Sending user id");
        sendcmd(s);
        int r=readreply();
        if(r==230) {
                //ok logged in
        } else if(r==331) {
                //send passsword
                if(argc>=3)
                        wsprintf(s,"pass %s\n",argv[2]);
                else
                        wsprintf(s,"pass\n");
                SetStatus(0,"Sending password");
                sendcmd(s);
                r=readreply();
                if(r!=230) {
                        MessageBox(hwndDialog,reply,"POC ftp - server error",MB_OK|MB_ICONSTOP);
                        abortScript=1;
                        return;
                }
        } else {
                MessageBox(hwndDialog,reply,"POC ftp - server error",MB_OK|MB_ICONSTOP);
                abortScript=1;
                return;
        }
                
}

static void do_cd() {
        //arguments: dir
        SetStatus("Changing directory","");
        if(argc!=2) {
                MessageBox(hwndDialog,"cd: incorrect number of arguments","poc ftp",MB_OK);
                abortScript=1;
                return;
        }
        char s[80];
        wsprintf(s,"cwd %s\n",argv[1]);
        sendcmd(s);
        int r=readreply();
        if(r!=250) {
                MessageBox(hwndDialog,reply,"POC ftp - server error",MB_OK|MB_ICONSTOP);
                abortScript=1;
                return;
        }
}

static void do_bin() {
        //arguments:
        SetStatus("Changing to binary mode","");
        if(argc!=1) {
                MessageBox(hwndDialog,"bin: incorrect number of arguments","poc ftp",MB_OK);
                abortScript=1;
                return;
        }
        sendcmd("type i\n");
        int r=readreply();
        if(r!=200) {
                MessageBox(hwndDialog,reply,"POC ftp - server error",MB_OK|MB_ICONSTOP);
                abortScript=1;
                return;
        }
}

static void do_lcd() {
        //arguments: dir
        SetStatus("Changing local directory","");
        if(argc!=2) {
                MessageBox(hwndDialog,"lcd: incorrect number of arguments","poc ftp",MB_OK);
                abortScript=1;
                return;
        }

        if(argv[1][1]==':') {
                //change drive
                unsigned drive;
                if(argv[1][0]>='A' && argv[1][0]<='Z')
                        drive = argv[1][0] - 'A' + 1;
                else if(argv[1][0]>='a' && argv[1][0]<='z')
                        drive = argv[1][0] - 'a' + 1;
                else
                        return;
                unsigned dontcare;
                _dos_setdrive(drive,&dontcare);
        }
        if(argv[1][2]) {
                //change dir
                if(chdir(argv[1])!=0) {
                        MessageBox(hwndDialog,"Could not change local directory","poc ftp",MB_OK);
                        abortScript=1;
                        return;
                }
        }
}

static void do_get() {
        //arguments: remotefile [localfile]
        SetStatus("Retrieving","");
        if(argc<2 || argc>3) {
                MessageBox(hwndDialog,"User: incorrect number of arguments","poc ftp",MB_OK|MB_ICONSTOP);
                abortScript=1;
                return;
        }
        char s[80];
        wsprintf(s,"Retrieving %s",argv[1]);
        SetStatus(s,"");

        //SIZE
        SetStatus(0,"Getting file size");
        wsprintf(s,"size %s\n",argv[1]);
        sendcmd(s);
        int r=readreply();
        long totalbytes=-1;
        if(r==213) {
                totalbytes = atol(reply+4);
        }
        if(abortScript) return;

        //PASV
        sendcmd("pasv\n");
        r = readreply();
        if(r!=227) {
                MessageBox(hwndDialog,"Server does not support passive mode","POC ftp",MB_OK|MB_ICONSTOP);
                abortScript=1;
                return;
        }

        char *pp=strchr(reply,'(');
        if(!pp) {
                MessageBox(hwndDialog,"Unexpected reply from server to 'PASV' command","POC ftp",MB_OK|MB_ICONSTOP);
                abortScript=1;
                return;
        }

        u_long a1,a2,a3,a4;
        u_short p1,p2;
        sscanf(pp+1,"%ld,%ld,%ld,%ld,%hd,%hd",&a1,&a2,&a3,&a4,&p1,&p2);
        sData = ::socket(PF_INET,SOCK_STREAM,0);
        if(sData==INVALID_SOCKET) {
                MessageBox(hwndDialog,"Could not create data socket","poc ftp",MB_OK|MB_ICONSTOP);
                abortScript=1;
                return;
        }
        u_long a = (a1<<24)|(a2<<16)|(a3<<8)|(a4);
        u_short p = (p1<<8)|(p2);
        
        struct sockaddr_in name;
        memset(&name,0,sizeof(name));
        name.sin_family = AF_INET;
        name.sin_addr.s_addr = htonl(a);
        name.sin_port = htons(p);
        SetStatus(0,"Opening data connection");
        if(::connect(sData,(sockaddr*)&name,sizeof(name))!=0) {
                MessageBox(hwndDialog,"Could not open data connection","poc ftp",MB_OK|MB_ICONSTOP);
                abortScript=1;
                return;
        }

        SetStatus(0,"Issuing retrieve command");
        wsprintf(s,"retr %s\n",argv[1]);
        sendcmd(s);
        r = readreply();
        if(r!=125 && r!=150) {
                char msg[512];
                wsprintf(msg,"Unexpected reply from server to 'RETR' comand:\n%s",reply);
                MessageBox(hwndDialog,msg,"POC ftp",MB_OK|MB_ICONSTOP);
                abortScript=1;
                return;
        }

        SetStatus(0,"Creating local file");
        FILE *fp;
        if(argc>=3)
                fp=fopen(argv[2],"wb");
        else
                fp=fopen(argv[1],"wb");
        if(!fp) {
                MessageBox(hwndDialog,"Could not create local file","POC ftp",MB_OK|MB_ICONSTOP);
                abortScript=1;
                return;
        }
        
        long bytesreceived=0;
        DWORD lastTickCount=0;
        static char buf[4096];
        for(;;) {
                DWORD tc=GetTickCount();
                if(tc>lastTickCount+500) {
                        if(totalbytes!=-1)
                                wsprintf(s,"Retrieved %ld of %ld bytes",bytesreceived,totalbytes);
                        else
                                wsprintf(s,"Retrieved %ld bytes",bytesreceived);
                        SetStatus(0,s);
                        lastTickCount=tc;
                }
                
                int b=::recv(sData,buf,4096,0);
                if(b>0) {
                        if(fwrite(buf,1,b,fp)!=b) {
                                MessageBox(hwndDialog,"Could not write to local file (disk full?)","POC ftp",MB_OK|MB_ICONSTOP);
                                abortScript=1;
                                return;
                        }
                } else if(b==0) {
                        break;
                } else {
                        //huh?
                        abortScript=1;
                        break;
                }
                bytesreceived+=b;
                
                PeekMessageLoop();
                if(abortScript)
                        break;
        }
        fclose(fp);
        SetStatus(0,"Closing data connection");
        closesocket(sData); sData=INVALID_SOCKET;
        r = readreply();
        if(r!=226 && !abortScript) {
                char msg[512];
                wsprintf(msg,"Data transfer did not complete:\n%s",reply);
                MessageBox(hwndDialog,msg,"POC ftp",MB_OK|MB_ICONSTOP);
                abortScript=1;
                return;
        }
}

static void do_noop() {
}

static void do_quit() {
        SetStatus("Quitting","");
        sendcmd("quit\n");
        readreply();
        closesocket(sControl); sControl=INVALID_SOCKET;
        SetStatus("","");
}


//Status dialog stuff----------------------------------------------------------

BOOL CALLBACK StatusDlgProc(HWND /*hwnd*/, UINT msg, WPARAM wParam, LPARAM /*lParam*/) {
        switch(msg) {
                case WM_INITDIALOG:
                        return TRUE;
                case WM_COMMAND: {
                        if(wParam==IDCANCEL) {
                                abortScript=1;
                                if(WSAIsBlocking())
                                        WSACancelBlockingCall();
                        }
                        return TRUE;
                }
                default:
                        return FALSE;
        }
}

static FARPROC lpProc;
static void ShowStatusDialog(HINSTANCE hinst) {
        lpProc = MakeProcInstance((FARPROC)StatusDlgProc, hinst);
        hwndDialog = CreateDialog(hinst, MAKEINTRESOURCE(100), NULL, (DLGPROC)lpProc);
        SetStatus("","");
        ShowWindow(hwndDialog,SW_SHOW);
}

static void RemoveStatusDialog() {
        DestroyWindow(hwndDialog);
        hwndDialog=NULL;
        FreeProcInstance(lpProc);
        lpProc=0;
}

static void SetStatus(const char *s1, const char *s2) {
        if(s1)
                SetDlgItemText(hwndDialog,ID_STATUS1,s1);
        if(s2)
                SetDlgItemText(hwndDialog,ID_STATUS2,s2);
}

static void PeekMessageLoop() {
        MSG msg;
        while(PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
                if(msg.message==WM_QUIT) {
                        PostMessage(hwndDialog,WM_QUIT,msg.wParam,msg.lParam);
                        return;
                }
                TranslateMessage(&msg);
                DispatchMessage(&msg);
        }
        
}



//main-------------------------------------------------------------------------
int PASCAL FAR WinMain(HINSTANCE hinst, HINSTANCE, LPSTR lpCmdLine, int) {
        script=fopen(lpCmdLine,"r");
        if(!script) {
                MessageBox(NULL,"Could not open script file","POC ftp",MB_OK|MB_ICONSTOP);
                return 1;
        }

        WSADATA wsadata;
        if(WSAStartup(0x0101,&wsadata)!=0) {
                MessageBox(NULL, "Could not initialize sockets","POC ftp",MB_OK|MB_ICONSTOP);
                fclose(script);
                return 2;
        }
        
        ShowStatusDialog(hinst);
        do {
                readScriptCommand();
                switch(cmd) {
                        case cmd_open:
                                do_open();
                                break;
                        case cmd_user:
                                do_user();
                                break;
                        case cmd_cd:
                                do_cd();
                                break;
                        case cmd_bin:
                                do_bin();
                                break;
                        case cmd_lcd:
                                do_lcd();
                                break;
                        case cmd_get:
                                do_get();
                                break;
                        case cmd_noop:
                                do_noop();
                                break;
                        case cmd_quit:
                        default:
                                do_quit();
                                break;
                }
                                
        } while(cmd!=cmd_quit && !abortScript);
        RemoveStatusDialog();

        if(sControl!=INVALID_SOCKET)
                closesocket(sControl);
        if(sData!=INVALID_SOCKET)
                closesocket(sData);
                
        WSACleanup();
        
        fclose(script);
        
        return 0;
}

